"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _reactDom2 = _interopRequireDefault(_reactDom);

var _App = require("./App");

var _App2 = _interopRequireDefault(_App);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import registerServiceWorker from "./registerServiceWorker";

var Index = function Index(props) {
  return _react2.default.createElement(
    _App2.default,
    _extends({ showAlertComment: true, showAlertReply: true, showAlertFavor: true, showError: true }, props),
    _react2.default.createElement(_App.Editor, { maxUpload: 9, autoFocus: true })
  );
};

/**
 * 渲染评论组件
 * @param {object} config 编辑器配置
 *  - {string} id 渲染评论的DOM的 ID
 *  - {number} type 评论的 type
 *  - {string} businessId 评论的 businessId
 *  - {string} API, API 前缀, 默认 http://api.links123.net/comment/v1
 */
function renderComment(config) {
  if (!config.id) {
    throw new Error("id is required");
  }
  if (!config.type) {
    throw new Error("type is required");
  }
  if (!config.businessId) {
    // throw new Error("businessId is required");
    console.warn("没有传入 businessId 参数，默认使用: test");
  }
  if (!config.API) {
    // throw new Error("API is required");
    console.warn("没有传入 API 参数，默认使用: http://api.links123.net/comment/v1");
  }
  var id = config.id,
      _config$type = config.type,
      type = _config$type === undefined ? 1 : _config$type,
      _config$businessId = config.businessId,
      businessId = _config$businessId === undefined ? "test" : _config$businessId,
      _config$API = config.API,
      API = _config$API === undefined ? "http://api.links123.net/comment/v1" : _config$API,
      userId = config.userId;


  _reactDom2.default.render(_react2.default.createElement(Index, { type: type, businessId: businessId, API: API, userId: userId }), document.getElementById(id));
  // registerServiceWorker();
}

window.renderComment = renderComment;

// renderComment({
//   id: "root-comment",
//   type: 1,
//   businessId: "test",
//   API: 'http://api.links123.net/comment/v1',
// });
//# sourceMappingURL=index.js.map